/* example_alg.cpp
 * 
 * Example
 * Energy exhausting attacks detection
 * 
 */
 
#include "stdafx.h"
#include <iostream> 
#include "libRNGnet.h" 
#include "EEAprev.h"

typedef std::tr1::mt19937 Myeng; 
typedef shifted_exponential<double> Mydist;
   
   
int main()
{	
	Myeng core; 
    double value1 = 1.0;
	double value2 = 1.0;
	Mydist flow(value1, value2);
	
	Mydist::input_type engval = core(); 
    Mydist::result_type distval = flow(core);			
	
	double threshold = GetThreshold(value1, value2);
	
	int j = 0;
	double sample; 
	bool alarm = false;
	
	GetAttack();

	while (!alarm) 
	{
		j++;
		if (j<attack_moment) 
		{
			sample = flow(core);
			std::cout << j << " sec: Normal Case" << std::endl;
		}
		else 
		{	
			sample = attack_intensity;
			std::cout << j << " sec: Attack" << std::endl;
		}
		if (xCUSUM(sample, threshold) == 1) alarm = true;
	}
	std::cout << "Alarm Delay : " << j - attack_moment << std::endl; 
	
	return 0;
}
 